      SUBROUTINE MNB2R(N,X,S,XX,A,B,EPS,C,FC,MAXK,FUN,IERR)
         INTEGER IERR,MAXK,N
         REAL A,B,C,EPS,FC,S,X,XX
         DIMENSION S(N),X(N),XX(N)
         INTEGER I,K
         REAL DELK,FA,FB,FE,FIMN,FIMX,FXLA,FXMU,XLA,XMU
       K = 0
       IERR = 0
       C = (A + B)/2.
       DO 10 I = 1, N
          XX(I) = X(I) + A*S(I)
   10  CONTINUE
       CALL FUN(XX,FA,FE)
       DO 20 I = 1, N
          XX(I) = X(I) + C*S(I)
   20  CONTINUE
       CALL FUN(XX,FC,FE)
       DO 30 I = 1, N
          XX(I) = X(I) + B*S(I)
   30  CONTINUE
       CALL FUN(XX,FB,FE)
   40  CONTINUE
       DELK = B - A
       IF (DELK - EPS) 120, 50, 50
   50  CONTINUE
       XMU = (A + C)/2.
       XLA = (C + B)/2.
       DO 60 I = 1, N
          XX(I) = X(I) + XMU*S(I)
   60  CONTINUE
       CALL FUN(XX,FXMU,FE)
       DO 70 I = 1, N
          XX(I) = X(I) + XLA*S(I)
   70  CONTINUE
       CALL FUN(XX,FXLA,FE)
       FIMN = AMIN1(FA,FXMU,FC,FXLA,FB)
       FIMX = AMAX1(FA,FXMU,FC,FXLA,FB)
       IF (FIMX - FIMN .LE. EPS*0.01) GO TO 110
          IF (FA .EQ. FIMN .OR. FXMU .EQ. FIMN) GO TO 80
             IF (FB .EQ. FIMN .OR. FXLA .EQ. FIMN) GO TO 90
                A = XMU
                FA = FXMU
                B = XLA
                FB = FXLA
                GO TO 100
   80     CONTINUE
          B = C
          FB = FC
          C = XMU
          FC = FXMU
          GO TO 100
   90  CONTINUE
       A = C
       FA = FC
       C = XLA
       FC = FXLA
  100  CONTINUE
       K = K + 1
       IF (K .LT. MAXK) GO TO 40
          IERR = 65
          GO TO 120
  110  CONTINUE
       IERR = 66
  120  RETURN
      END
